local addonName, addonTable = ...
local au = AmendUIFuncs

function au.SetupDruidManaBar()
    -- ***** Druid MP Parent Frame *****
    au.DruidMP = CreateFrame("Frame", "AmendUIDruidMPFrame", PlayerFrameManaBar)
    au.DruidMP:SetSize(124, 15)
    au.DruidMP:ClearAllPoints()
    au.DruidMP:SetPoint("TOPLEFT", PlayerFrameManaBar, "BOTTOMLEFT", -1, 1)
    au.DruidMP:SetFrameStrata("LOW")

    -- ***** Druid MP Status Bar *****
    au.DruidMP.bar = CreateFrame("StatusBar", "AmendUIDruidMPFrameStatusBar", au.DruidMP)
    au.DruidMP.bar:SetWidth(118)
    au.DruidMP.bar:SetHeight(10)
    au.DruidMP.bar:SetPoint("TOPLEFT", au.DruidMP, "TOPLEFT", 3, -3)
    au.DruidMP.bar:SetStatusBarTexture("Interface\\TargetingFrame\\UI-StatusBar")
    au.DruidMP.bar:SetStatusBarColor(25 / 255, 25 / 255, 255 / 255)

    -- ***** Druid MP Border *****
    au.DruidMP.bar.border = au.DruidMP.bar:CreateTexture("AmendUIDruidMPFrameStatusBarBorder", "OVERLAY")
    au.DruidMP.bar.border:SetTexture("Interface\\Tooltips\\UI-StatusBar-Border")
    au.DruidMP.bar.border:SetAllPoints(au.DruidMP)

    -- ***** Druid MP BG *****
    au.DruidMP.bar.bg = au.DruidMP.bar:CreateTexture("AmendUIDruidMPFrameStatusBarBG", "BACKGROUND")
    au.DruidMP.bar.bg:SetTexture("Interface\\TARGETINGFRAME\\UI-StatusBar")
    au.DruidMP.bar.bg:SetAllPoints(au.DruidMP.bar)
    au.DruidMP.bar.bg:SetVertexColor(0, 0, 0, 0.3)

    -- ***** Mouseover XP Text *****
    au.DruidMP.bar.textleft =
    au.DruidMP.bar:CreateFontString("AmendUIDruidMPFrameStatusBarTextLeft", "OVERLAY", "TextStatusBarText")
    au.DruidMP.bar.textleft:SetPoint("LEFT", au.DruidMP, "LEFT", 6, 1)
    au.DruidMP.bar.textleft:SetJustifyH("LEFT")
    au.DruidMP.bar.textleft:SetJustifyV("CENTER")
    au.DruidMP.bar.textleft:SetText("Mana")
    au.DruidMP.bar.textleft:Hide()

    au.DruidMP.bar.textright =
    au.DruidMP.bar:CreateFontString("AmendUIDruidMPFrameStatusBarTextRight", "OVERLAY", "TextStatusBarText")
    au.DruidMP.bar.textright:SetPoint("RIGHT", au.DruidMP, "RIGHT", -6, 1)
    au.DruidMP.bar.textright:SetJustifyH("RIGHT")
    au.DruidMP.bar.textright:SetJustifyV("CENTER")
    au.DruidMP.bar.textright:Hide()

    au.DruidMP:SetScript("OnEnter",
        function()
            au.DruidMP.bar.textleft:Show()
            au.DruidMP.bar.textright:Show()
        end
    )
    au.DruidMP:SetScript("OnLeave",
        function()
            au.DruidMP.bar.textleft:Hide()
            au.DruidMP.bar.textright:Hide()
        end
    )

    au.UpdateDruidManaBar()
    au.ShowHideDruidManaBar()

    --Bar Updater
    au.DruidMP:RegisterEvent("UNIT_POWER_UPDATE")
    au.DruidMP:RegisterEvent("UPDATE_SHAPESHIFT_FORM")
    au.DruidMP:SetScript("OnEvent",
        function(self, event)
            if (event == "UNIT_POWER_UPDATE") then
                au.UpdateDruidManaBar()
            elseif (event == "UPDATE_SHAPESHIFT_FORM") then
                au.ShowHideDruidManaBar()
            end
        end
    )
end

function au.UpdateDruidManaBar()
    local curHP = UnitPower("player", 0)
    local maxHP = UnitPowerMax("player", 0)
    au.DruidMP.bar:SetMinMaxValues(0, maxHP)
    au.DruidMP.bar:SetValue(curHP)
    au.DruidMP.bar.textright:SetText(curHP .. " / " .. maxHP)
end

function au.ShowHideDruidManaBar()
    local druidform = GetShapeshiftForm()
    if (druidform == 1 or druidform == 3) then
        au.DruidMP:Show()
    else
        au.DruidMP:Hide()
    end
end
