local addonName, addonTable = ...
local au = AmendUIFuncs

-- ************* Minimap **************
-- Code taken from NoUI

-- Zoom minimap with mousewheel
function au.MouseWheelMinimapZoom(self, arg1)
    if arg1 > 0 and self:GetZoom() < 5 then
        -- Zoom in
        MinimapZoomOut:Enable()
        PlaySound(SOUNDKIT.IG_MINIMAP_ZOOM_IN)
        self:SetZoom(self:GetZoom() + 1)
        if(Minimap:GetZoom() == (Minimap:GetZoomLevels() - 1)) then
            MinimapZoomIn:Disable()
        end
    elseif arg1 < 0 and self:GetZoom() > 0 then
        -- Zoom out
        MinimapZoomIn:Enable()
        PlaySound(SOUNDKIT.IG_MINIMAP_ZOOM_OUT)
        self:SetZoom(self:GetZoom() - 1)
        if(Minimap:GetZoom() == 0) then
            MinimapZoomOut:Disable()
        end
    end
end

function au.SetupMinimap()
    if(au.global_prefs.Minimap== false) then return end
    -- Set minimap zone text font to outline
    local fontPath, fontSize, fontFlags = MinimapZoneText:GetFont()
    MinimapZoneText:SetFont(fontPath, fontSize, 'OUTLINE')
    -- Center minimap zone text
    MinimapZoneTextButton:ClearAllPoints()
    MinimapZoneTextButton:SetPoint('CENTER', MinimapCluster, 'CENTER', 0+8, 83+4)
    -- Hide minimap zone text chrome
    MinimapBorderTop:Hide()
    MinimapToggleButton:Hide()
    MiniMapWorldMapButton:Hide()

    -- Hide minimap zoom buttons
    MinimapZoomIn:Hide()
    MinimapZoomOut:Hide()

    -- Hide day/night
    GameTimeFrame:Hide()

    Minimap:EnableMouseWheel(true)
    Minimap:SetScript("OnMouseWheel", au.MouseWheelMinimapZoom)
end

-- ************************************
